/* 
    qasn1 - Asn1BerParser - parser class for qasn1 library
    Copyright(C) 2010 - Andrius da Costa Ribas

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ASN1BERPARSER_H
#define ASN1BERPARSER_H

#include <QtCore/QBuffer>
#include <QProgressDialog>
#include "qasn1_export.h"
#include "Asn1BerNode.h"

class Asn1BerParserPrivate;
class QASN1_EXPORT Asn1BerParser
{
private:
    Asn1BerParserPrivate* d;
    
public:
    Asn1BerParser(QIODevice* inputStream, Asn1BerParser* parentParser=0);
    Asn1BerParser(QIODevice* inputStream, int endOffset);
    virtual ~Asn1BerParser();
    
    Asn1BerParser(QByteArray inputStream);
    
    Asn1BerNode* parse(Asn1BerNode* parentNode=0);
    
    int maxOffset();
    
    void enableProgressDialog(bool enabled=true);
    bool progressDialogEnabled();
    
    QProgressDialog* progressDialog();
};

#endif
